local _,N = ...
local Settings = {}
N.Settings = Settings
local D = LibStub:GetLibrary("DoomCore-2.0")
local opt = D.opt

local defaults = {}

defaults.global = {
  read = true,
  autoconfirm = true,
  completeRewards = true,
  anchor = "bottom",
  slideSpeed = 10,
  adjustAlerts = true,
  width = 570,
  scale = 0.75,
  offsetX = 0,
  offsetY = 96,
  animate = "once",
  buttonWidth = 250,
  buttonHeight = 40,
  buttonScale = 1,
  perRow = 3,
  differentHeights = false,
  -- Keybindings
  next = "SPACE",
  auto = "TAB",
  back = "BACKSPACE",
  close = "ESCAPE",
  ["1"] = "1",
  ["2"] = "2",
  ["3"] = "3",
  ["4"] = "4",
  ["5"] = "5",
  ["6"] = "6",
  ["7"] = "7",
  ["8"] = "8",
  ["9"] = "9",
  ["10"] = "0",
  ["11"] = "-",
  ["12"] = "=",
  titleFont = "Morpheus",
  titleSize = 22,
  textFont = "Friz Quadrata TT",
  textSize = 16,
  choiceFont = "Friz Quadrata TT",
  choiceSize = 14
}

defaults.main = {
}
defaults.db = {
  profile = {
  }
}
local function isAlert()
  return N.Handler.core.adjustAlerts
end
defaults.options = opt("parent", {
  set = "Rebuild",
  childGroups = "tab",
  args = {
    { "read", "toggle", "Use for reading books", { width = "full" } },
    { "autoconfirm", "toggle", { width = "full" } },
    { "finished", "toggle", "Show completed tasks", { width = "full" } },
    { "completeRewards", "toggle", "Show rewards when completing a quest", { width = "full" } },
    { "rewards", "toggle", "Include rewards in objective description", { width = "full" } },
    { "conceal", "toggle", "Hide UI while talking", { width = "full" } },
    { "slideshow", "toggle", "Progress automatically" },
    { "slideSpeed", "range", "Delay (s)", {
      min = 0.5,
      max = 60,
      softMax = 20,
      disabled = ({ false, "slideshow" })
    } },
    { "keybindings", "header" },
    { "next", "keybinding" },
    { "auto", "keybinding", "Autoselect" },
    { "back", "keybinding" },
    --{ "close", "keybinding", { disabled = true } },
    { "space" },
    { "1", "keybinding", "Option 1", { width = "half" } },
    { "2", "keybinding", "Option 2", { width = "half" } },
    { "3", "keybinding", "Option 3", { width = "half" } },
    { "4", "keybinding", "Option 4", { width = "half" } },
    { "5", "keybinding", "Option 5", { width = "half" } },
    { "6", "keybinding", "Option 6", { width = "half" } },
    { "space" },
    { "7", "keybinding", "Option 7", { width = "half" } },
    { "8", "keybinding", "Option 8", { width = "half" } },
    { "9", "keybinding", "Option 9", { width = "half" } },
    { "10", "keybinding", "Option 10", { width = "half" } },
    { "11", "keybinding", "Option 11", { width = "half" } },
    { "12", "keybinding", "Option 12", { width = "half" } },
    { "dialogue", "header" },
    { "width", "range", {
      min = 10,
      max = UIParent:GetWidth() or 100,
      softMin = 50,
      softMax = 700
    } },
    { "scale" },
    { "space" },
    { "adjustAlerts", "toggle", "Treat as alert" },
    { "anchor", { disabled = isAlert } },
    { "space", },
    { "offsetX", { disabled = isAlert } },
    { "offsetY", { disabled = isAlert } },
    { "space" },
    { "animate", "select", "Animate talking heads", {
      values = { "once", "never", "loop" }
    } },
    { "choices", "header" },
    { "buttonWidth", "range", "Width", {
      min = 10,
      max = 500,
      softMin = 50
    } },
    { "buttonHeight", "range", "Height", {
      min = 10,
      max = 500,
      softMax = 200
    } },
    { "buttonScale", "scale", "Scale" },
    { "perRow", "range", "Per row", {
      min = 1,
      max = 50,
      softMax = 10
    } },
    { "space" },
    { "differentHeights", "toggle", "Allow different heights", {
      width = "double"
    } },
    { "fonts", "header" },
    { "titleFont", "font", "Title" },
    { "titleSize", "fontSize" },
    { "space" },
    { "textFont", "font", "Text" },
    { "textSize", "fontSize" },
    { "space" },
    { "choiceFont", "font", "Choices" },
    { "choiceSize", "fontSize" }
  }
}
)
Settings.defaults = defaults

Settings.debug = {
}